
	;INC code for handling the timer and interrupts
			;look at lcc1802prolocx.inc for all macros
_setCount:
	;cpy2 R15,R12 ;copy the first input parameter to the return value
	GLO R12 ;we fetch the value requested
	LDC ;load to the counter
	cretn
_getCount: 
	GEC
	PLO R15
	cretn

_stopCount:
	STPC ;stop the counter
	GEC ;get counter
	PLO R15 ;return the counter value to the code
	cretn
_startTimer: ;0, starts the counter, 1 uses EF1 as the clock, 2 uses EF2 as the clock, 3 uses EF1 and sets as pulse with mode(note 1), 4 uses EF2 and sets as pulse with mode
			 ;note1: if EF1/EF2 goes high on mode 3 and mode 4 respectivly, the counter stops, this can be used with a constant indempendent clock to make delays that adjust without using the cpuclock on the compiler
			 
	;GLO R12; this is important
	STM ;simplest thing in here
	cretn
	
_decrementCounter:
	DTC
	cretn
	
_externalINTdisable:
	XID
	cretn
	
_externalINTenable:
	XIE
	cretn
	
_counterINTdisable:
	CID
	cretn
	
_counterINTenable:
	CIE
	cretn
	;check EF1
_TEF1:
	ldi 0		;default is false
	plo R15
	phi R15
	b1 $$skpEF1		;i have to reverse the sense of the external line
	inc R15		;if external line is high, supply a 1
$$skpEF1: 
	cretn
	
_TEF2:
	ldi 0		;default is false
	plo R15
	phi R15
	b2 $$skpEF2		;i have to reverse the sense of the external line
	inc R15		;if external line is high, supply a 1
$$skpEF2: 
	cretn
	
_TEF3:
	ldi 0		;default is false
	plo R15
	phi R15
	b3 $$skpEF3		;i have to reverse the sense of the external line
	inc R15		;if external line is high, supply a 1
$$skpEF3: 
	cretn
	
_TEF4:
	ldi 0		;default is false
	plo R15
	phi R15
	b1 $$skpEF4		;i have to reverse the sense of the external line
	inc R15		;if external line is high, supply a 1
$$skpEF4: 
	cretn
;_EFID: ;EF pin identifier it checks if the target pin is set (goes from 1 to 4)
