//#include "nstdlib.h"
/* Global vars have been known to cause issues
const char masktxRDY = 0x04; //bit mask 0000 01 00 to test txready
const char maskEMT = 0x08; //bit mask 0000 10 00 to test txEMT
const char maskrxRDY = 0x01; //bit one, rx ready
const char maskFFUL = 0x02; //test for fifo full
*/
void sccDEFAULT(){ //default start, 9600 boundrate
	out(1,0x01);//select port b
	out(4,0x02); //CRA
	out(6,0x10); // 00010000 set pointer to MR1A
				
	out(4,0x00); //adress 00 //MR1A//MR2A
	out(6,0x53); //010 10 0 11 decimal 83
	out(6,0x07); //00 0 0 0111 //normal,no rts control,no cts control, 1 stop bit decimal 
	
	out(4,0x02); //CRA
	out(6,0x05); // 0000 0101 

	out(4,0x01); //csra
	out(6,0xBB); //9600 bound rate is 1011 1011
	

	out(4,0x02); //CRA
	out(6,0x05); // 0000 0101
}

void sccOUT(char x){ //on your main file do <#define putc(x) sccOUT(x);> 
	out(1,0x01); //be sure we are on port b
	//printf gives us X char
	out(4, 0x01); //SRA
	while(!(inp(6) & 0x04));//await in case tx isnt ready
	out(4,0x03); //select TXHA
	out(6,x); //there
}

void sccOUTnolock(char x){ //on your main file do <#define putc(x) sccOUT(x);> 
	out(1,0x01); //be sure we are on port b
	//printf gives us X char
	out(4, 0x01); //SRA
	//while(!(inp(6) & 0x04));//await in case tx isnt ready
	out(4,0x03); //select TXHA
	out(6,x); //there
}

char sccIN(){
	char buffer;
	out(1,0x01); //be sure we are on port b
	out(4, 0x01); //SRA
	while(!(inp(6) & 0x01));
	out(4,0x03); //select TXHA
	buffer = inp(6);
	return buffer; //we should only do so if its 0x0D at SRA
}

char sccINnonBlocking(){
	char buffer;
	out(1,0x01); //be sure we are on port b
	out(4, 0x01); //SRA
	while(!(inp(6) & 0x01));
	if(inp(6) & 0x01){
	out(4,0x03); //select TXHA
	buffer = inp(6);
	}else{
	buffer = 0x15; //return NAK not aknowladged	
	}
	return buffer; //we should only do so if its 0x0D at SRA
}


//#include <nstdlib.c>

/*
assembly idea
	;sex 3\n out 1\n db 1\n sex 2\n
	;set to portB
	sex 3
	out 1
	db 1
	sex 2
	;go to UART R1
	sex 3
	out 4
	db 1
	sex 2
	;read status
	$$checkloop:
	INP 6 ; check state of UART
	XRI 0x01 ;check if its ready
	BNZ $$checkloop ;if not 0 wich would be so if its bit was set, we wait
	;else we go to UART R3 to send data
	sex 3
	out 4
	db 3
	sex 2
	
	;get char
	sex 3
	out 6
	db 1
	sex 2
*/

/*
;better assembly
when you enter your function like sccOUT(x) the value of x is in R12 so you can do:
 dec 2
 glo 12
 stn 2
 out < your port>
 cretn

that's still a bunch of instructions because the call/return sequence is 15 or so

to return a value from sccIN just put it in R15 (maybe zero the top byte)

;code

_sccOUTASM:

	;set to portB
	sex 3
	out 1
	db 1
	sex 2
	;go to UART R1
	sex 3
	out 4
	db 1
	sex 2
	
	$$checkready:
	inp 6
	XRI 0x04
	BNZ $$checkready ;loop untill ready

	dec 2
	glo 12
	stn 2
	out 6
	cretn


_sccINASM:

	;set to portB
	sex 3
	out 1
	db 1
	sex 2
	;go to UART R1
	sex 3
	out 4
	db 1
	sex 2
	
	$$checkchararrived:
	inp 6
	XRI 0x01
	BNZ $$checkchararrived ;loop untill ready

	;go to UART R3
	sex 3
	out 4
	db 3
	sex 2
	
	inp 6
	plo 15
	
	cretn


char sccIN(){
	char buffer;
	out(1,0x01); //be sure we are on port b
	out(4, 0x01); //SRA
	while(!(inp(6) & 0x01));
	out(4,0x03); //select TXHA
	buffer = inp(6);
	return buffer; //we should only do so if its 0x0D at SRA
}

*/


