
	;INC code for handling the timer and interrupts
	;look at lcc1802prolocx.inc for all macros
_setCount:
	;cpy2 R15,R12 ;copy the first input parameter to the return value
	GLO R12 ;we fetch the value requested
	LDC ;load to the counter
	cretn
_getCount: 
	GEC
	PLO R15
	cretn

_stopCount:
	STPC ;stop the counter
	GEC ;get counter
	PLO R15 ;return the counter value to the code
	cretn
_startTimer: ;0, starts the counter, 1 uses EF1 as the clock, 2 uses EF2 as the clock, 3 uses EF1 and sets as pulse with mode(note 1), 4 uses EF2 and sets as pulse with mode
			 ;note1: if EF1/EF2 goes high on mode 3 and mode 4 respectivly, the counter stops, this can be used with a constant indempendent clock to make delays that adjust without using the cpuclock on the compiler
			 
	;GLO R12; this is important
	STM ;simplest thing in here
	cretn
	
_decrementCounter:
	DTC
	cretn
	
_externalINTdisable:
	XID
	cretn
	
_externalINTenable:
	XIE
	cretn
	
_counterINTdisable:
	CID
	cretn
	
_counterINTenable:
	CIE
	cretn
	;check EF1

	;added by patina, for the SBC1806
	align 64	;needed to make sure all on same page
_controlWrite:
	glo regArg1	;get the bit number
	adi $$bvtable2&255	;add the table offset
	plo memaddr
	ghi RPC		;get the top byte of the current page
	phi memaddr	
	ldn memaddr	;pick up the bit pattern
	plo rt1		;save it in a temp
	ldAD memaddr,_CTRLREGIO1 ;address the current port value
	sex memaddr	;prepare to change it
	glo regArg2	;get on/off switch
	bz $$setbitoff1
; here we have the bit pattern in rt1 and we're ready to apply it with OR
	glo rt1		;get the bit value back
	or		;apply it
	str memaddr	;and save it
	br $$outit1	;go fnish up
$$setbitoff1:
	glo rt1		;get the bit pattern
	xri 0xff	;reverse it
	and		;combine it with the existing pin value
	str memaddr	;and save it
;here we gave set/reset the correct bit in PIN4 and we just have to send it out
$$outit1:
	out 1		;X was already set to memaddr
	sex sp		;reset X
	cretn
	
	
$$bvtable2 db 1,2,4,8,16,32,64,128	;table of bit values
	


_controRead:
	ldAD memaddr,_CTRLREGIO1 ;address the current port value
	plo R15
	cretn
;digitalPort(unsigned char n, unsigned char hilo){ //select the IO and port

; digitalPort:
	
	; ldAD memaddr,_CTRLREGIO1 ;address the current port value
	; ORI 0x03 
	; sex memaddr
	; str memaddr
	; sex sp
	
	; ldAD memaddr,_CTRLREGIO1
	; GLO regArg1
	; ANI 0x03 ;bit mask for the PORT
	; sex memaddr
	
	
	

