;I2C_API.scc


;I2CRAM EQU $00 R15 ;received data
;I2CADDR EQU $00 ;todo: change this R12
;data to send is R13

SDAINmask equ $80; 1000 0000 so bit[7]
SDAOUTONmask equ $07
SCLHIGHmask equ $05
SCLLOWmask equ $04
SDAOUTOFFmask equ $06
PORTC EQU $02

	; //bit 3 is SDA
	; //bit 2 is SCL
	; //bit 7 is  SDA


_I2C_START:
;set to portC
	SEX R2

	DEC R2
	LDI PORTC
	STR R2
	out 1
;-------------

	
;-----------------
	DEC R2
	LDI $FF ;set SDA and SCL high
	STR R2
	out 2
;-----------------





;-----------------set SDA LOW prior to SCL
	
	SEX R2

	DEC R2
	LDI SDAOUTOFFmask ;turn SDA off
	STR R2
	out 2

	DEC R2
	LDI SCLLOWmask ;turn SCL off
	STR R2
	out 2
	
;-----------------

;-----------------send loop
	GLO R12 ;get target address ;;; so bit 7 is what sets the RW and bits[0..6] are the 7 bit address
	RSHL ;rotate with carry SHIFT D LEFT, MSB(D) → DF, DF → LSB(D)
	;DEC R2
	;STR R2;store the shifted value
	PLO R12 ;store the shifted value to R12 ;this is so we dont need RAM
_I2C_SEND_ADDRESS_LOOP:

	ANI $80;see if bit 7 is a 1
	LBZ SEND_0;if its 0, go to send 0, else run this
	DEC R2
	LDI SDAOUTONmask ;turn SDA on
	STR R2
	out 2
	
	DEC R2
	LDI SCLHIGHmask; turn SCL on
	STR R2
	out 2
	LBR PAST_SEND;skip the send 0 part
	
SEND_0:
	
	DEC R2
	LDI SDAOUTOFFmask ;turn SDA on
	STR R2
	out 2
	
	DEC R2
	LDI SCLHIGHmask; turn SCL on
	STR R2
	out 2
PAST_SEND:
	
	DEC R2
	LDI SCLLOWmask; turn SCL off
	STR R2
	out 2
	
	GLO R12; fetch the value we started
	SHL
	PLO R12 ;store it again prior to the output loops
	LBZ _I2C_SEND_ADDRESS_LOOP
	;set SCL and SDA HIGH after send
	DEC R2
	LDI $FF ;set SDA and SCL high
	STR R2
	out 2
	;then SCL Goes Low
	DEC R2
	LDI SCLLOWmask
	STR R2
	out 2
	;SDA is now free to switch
	
	
	;special part
	;since RW is now in DF we could use this
	LBNF _I2C_READ_BYTE ;read
	;else
	;continue to loop
	;-----
	
	
	
_I2C_SEND_BYTE: ;same thing as address one, just changes the register

	GLO R13 
	RSHL ;rotate with carry SHIFT D LEFT, MSB(D) → DF, DF → LSB(D)
	;DEC R2
	;STR R2;store the shifted value
	PLO R13 ;store the shifted value to R13 ;this is so we dont need RAM
_I2C_SEND_DATA_LOOP:

	ANI $80;see if bit 7 is a 1
	LBZ BYTESEND_0;if its 0, go to send 0, else run this
	DEC R2
	LDI SDAOUTONmask ;turn SDA on
	STR R2
	out 2
	
	DEC R2
	LDI SCLHIGHmask; turn SCL on
	STR R2
	out 2
	BR BYTEPAST_SEND;skip the send 0 part
	
BYTESEND_0:
	
	DEC R2
	LDI SDAOUTOFFmask ;turn SDA on
	STR R2
	out 2
	
	DEC R2
	LDI SCLHIGHmask; turn SCL on
	STR R2
	out 2
BYTEPAST_SEND:
	
	DEC R2
	LDI SCLLOWmask; turn SCL off
	STR R2
	out 2
	
	GLO R12; fetch the value we started
	SHL
	PLO R12 ;store it again prior to the output loops
	LBZ _I2C_SEND_DATA_LOOP

	Cretn ;return
	
_I2C_READ_BYTE:

	LDI $00
	PLO R15
	;clear R15
READ_BYTE_LOOP: 

	
	
	SEX R3
	out 2
	DB SCLHIGHmask; turn SCL on
	INP 2 ;read bit 7 ;lets say its one
	ANI SDAINmask ;1000 0000
	RSHL ;shift it ;0000 0001
	PLO R15
	
	SEX R3
	out 2
	DB SCLLOWmask; turn SCL off
	
	
	SEX R3
	out 2
	DB SCLHIGHmask; turn SCL on
	INP 2 ;read bit 7 ;lets say its one
	ANI SDAINmask ;1000 0000
	RSHL ;shift it ;0000 0001
	PLO R15
	
	SEX R3
	out 2
	DB SCLLOWmask; turn SCL off
	
	SEX R3
	out 2
	DB SCLHIGHmask; turn SCL on
	INP 2 ;read bit 7 ;lets say its one
	ANI SDAINmask ;1000 0000
	RSHL ;shift it ;0000 0001
	PLO R15
	
	SEX R3
	out 2
	DB SCLLOWmask; turn SCL off
	
	SEX R3
	out 2
	DB SCLHIGHmask; turn SCL on
	INP 2 ;read bit 7 ;lets say its one
	ANI SDAINmask ;1000 0000
	RSHL ;shift it ;0000 0001
	PLO R15
	
	SEX R3
	out 2
	DB SCLLOWmask; turn SCL off
	
	SEX R3
	out 2
	DB SCLHIGHmask; turn SCL on
	INP 2 ;read bit 7 ;lets say its one
	ANI SDAINmask ;1000 0000
	RSHL ;shift it ;0000 0001
	PLO R15
	
	SEX R3
	out 2
	DB SCLLOWmask; turn SCL off
	
	SEX R3
	out 2
	DB SCLHIGHmask; turn SCL on
	INP 2 ;read bit 7 ;lets say its one
	ANI SDAINmask ;1000 0000
	RSHL ;shift it ;0000 0001
	PLO R15
	
	SEX R3
	out 2
	DB SCLLOWmask; turn SCL off
	
	SEX R3
	out 2
	DB SCLHIGHmask; turn SCL on
	INP 2 ;read bit 7 ;lets say its one
	ANI SDAINmask ;1000 0000
	RSHL ;shift it ;0000 0001
	PLO R15
	
	SEX R3
	out 2
	DB SCLLOWmask; turn SCL off
	
	SEX R3
	out 2
	DB SCLHIGHmask; turn SCL on
	INP 2 ;read bit 7 ;lets say its one
	ANI SDAINmask ;1000 0000
	RSHL ;shift it ;0000 0001
	PLO R15
	
	SEX R3
	out 2
	DB SCLLOWmask; turn SCL off
	

	

	Cretn

;from 6502
; I2CRAM = $00
; I2CADDR = I2CRAM
; inb     = I2CRAM +1
; outb    = I2CRAM +2

; SCL     = 1 ; DRB0 bitmask
; SCL_INV = $FE ; Inverted for easy clear bit
; SDA     = 2 ; DRB1 bitmask
; SDA_INV = $FD

; DRA     = RIOT + $00 ;DRA ('A' side data register)
; DDRA    = RIOT + $01 ;DDRA ('A' side data direction register)
; DRB     = RIOT + $02 ;DRB ('B' side data register)
; DDRB    = RIOT + $03 ;('B' side data direction register)

; i2c_start:
  ;y lda I2CADDR
  ;y rol ; Shift in carry
  ;y sta outb ; Save addr + r/w bit

  ;y lda #SCL_INV
  ;y and DDRB
  ;y sta DDRB ; Start with SCL as input HIGH - that way we can inc/dec from here

  ;y lda #SDA ; Ensure SDA is output low before SCL is LOW
  ;y ora DDRB
  ;y sta DDRB
  ;y lda #SDA_INV
  ;y and DRB
  ;y sta DRB

  ;y lda #SCL_INV ; Ensure SCL is low when it turns to output
  ;y and DRB
  ;y sta DRB
  ;y inc DDRB ; Set to output by incrementing the direction register == OUT, LOW

  ; ; Fall through to send address + RW bit
  ; ; After a start condition we always send the address byte so we don't need to RTS+JSR again here

; i2cbyteout: ; Clears outb
  ; lda #SDA_INV ; In case this is a data byte we set SDA LOW
  ; and DRB
  ; sta DRB
  ; ldx #8
  ; bne first ; BRA - skip INC since first time already out, low
; I2Cbyteloop:
  ; inc DDRB ; SCL out, low
; first:
  ; asl outb ; MSB to carry
  ; bcc seti2cbit0 ; If bit was low
  ; lda DDRB       ; else set it high
  ; and #SDA_INV
  ; sta DDRB
  ; bcs wasone ; BRA doesn't exist on 6507
; seti2cbit0:
  ; lda DDRB
  ; ora #SDA
  ; sta DDRB
  ; wasone:
  ; dec DDRB
  ; dex
  ; bne I2Cbyteloop

  ; inc DDRB

  ; lda DDRB ; Set SDA to INPUT (HIGH)
  ; and #SDA_INV
  ; sta DDRB

  ; dec DDRB ; Clock high
  ; lda DRB  ; Check ACK bit
  ; sec
  ; and #SDA
  ; bne nack
  ; clc ; Clear carry on ACK
  ; nack:
  ; inc DDRB ; SCL low
  ; rts
; i2cbytein:
  ; ; Assume SCL is low from address byte
  ; lda DDRB  ; SDA, input
  ; and #SDA_INV
  ; sta DDRB
  ; lda #0
  ; sta inb
  ; ldx #8
; i2cbyteinloop:
  ; clc
  ; dec DDRB ; SCL HIGH
  ; lda DRB ; Let's read after SCL goes high
  ; and #SDA
  ; beq got0
  ; sec
  ; got0:
  ; rol inb ; Shift bit into the input byte
  ; inc DDRB ; SCL LOW
  ; dex
  ; bne i2cbyteinloop

  ; lda DDRB ; Send NACK == SDA high (only single bytes for now)
  ; and #SDA_INV
  ; sta DDRB
  ; dec DDRB ; SCL HIGH
  ; inc DDRB ; SCL LOW
; rts

; i2c_stop:
  ; lda DDRB ; SDA low
  ; ora #SDA
  ; sta DDRB
  ; dec DDRB ; SCL HIGH
  ; lda DDRB ; Set SDA high after SCL == Stop condition
  ; and #SDA_INV
  ; sta DDRB
  ; rts
; Oh - and this for setup.
; lda #$BC ; Bit 0, 1 are SCL and SDA, bit 6 is input button.
          ; sta DDRB ; Set B register direction to #%10111100