#define HEAP_START   0x8000
#define HEAP_END     0xAFFF

//unsigned char fakeRam[0x10000];
unsigned char *lastAddress;

//const char *state[] = {"FREE", "USED"};

void ramInit(void) {
    lastAddress = (unsigned char*)HEAP_START;
    *(unsigned short*)HEAP_START = (unsigned short)(HEAP_END - HEAP_START - 5);
    *(unsigned short*)(HEAP_START + 2) = 0;
    *(unsigned char*)(HEAP_START + 4) = 0;
}

/*
void ramDebug(void) {
    unsigned int address = HEAP_START;
    unsigned short size = 0;
    unsigned short previous = 0;

    while(address < HEAP_END) {
        size = *(unsigned short*)&fakeRam[address];
        previous = *(unsigned short*)&fakeRam[address + 2];
        printf("%d -> size: %d, address: %d, previous: %d, %s\n", address, size, address + 5, previous, state[fakeRam[address + 4]]);
        address += 5 + size;
    }
}
*/

unsigned char* malloc(unsigned short size) {
    unsigned char *currentAddress = lastAddress;
    unsigned char *endAddress = (unsigned char*)HEAP_END;
    unsigned char *newAddress;
    unsigned short newSize;
    unsigned char *previousAddress;

    unsigned short currentSize;
    unsigned char passes = 0;

    //there are to passes searching for free memory.
    //the first is from the last location to the end.
    //the second is from the start location to the last location.
    //maybe we have a better chance to find a free space quickly.

    while(passes < 2) {
        while(currentAddress < endAddress) {
            currentSize = *(unsigned short*)currentAddress;

            if(*(currentAddress + 4) == 0 && currentSize == size) {
                *(currentAddress + 4) = 1;
                return currentAddress + 5;
            }

            if(*(currentAddress + 4) == 0 && currentSize >= size + 5) {
                *(unsigned short*)currentAddress = size;
                currentAddress += 4;
                *currentAddress = 1;
                currentAddress++;

                newAddress = currentAddress + size;
                previousAddress = newAddress;
                lastAddress = newAddress;
                newSize = currentSize - size - 5;
                *(unsigned short*)newAddress = newSize;
                newAddress += 2;
                *(unsigned short*)newAddress = (unsigned short)(currentAddress - 5);
                newAddress += 2;
                *newAddress = 0;
                newAddress++;
                newAddress += newSize + 2;

                if(newAddress < (unsigned char*)HEAP_END) {
                    *(unsigned short*)newAddress = ((unsigned short)newAddress) - newSize - 7;
                }

                return currentAddress;
            }
            currentAddress += currentSize + 5;
        }
        passes++;
        currentAddress = (unsigned char*)HEAP_START;
        endAddress = lastAddress;
    }

    return 0;
}

void free(unsigned char *address) {
    unsigned char *nextAddress, *previousAddress;
    unsigned short size, nextSize;

    //address--, on the cdp maybe I will use a register for this
    //it is faster to use "dec Rx" than do the subtraction on a local variable :)
    address--;
    *address = 0;
    previousAddress = (unsigned char*)(*(unsigned short*)(address - 2));

    if(previousAddress != 0 && *(previousAddress + 4) == 0) {
        address = previousAddress;
    }
    else address -= 4;

    size = *(unsigned short*)address;
    nextAddress = address + 5 + size;

    //merging free space if the next one is also free.
    while((nextAddress < (unsigned char*)HEAP_END) && (*(nextAddress + 4) == 0)) {
        nextSize = *(unsigned short*)nextAddress;
        size += nextSize + 5;
        nextAddress += nextSize + 5;
    }

    if(nextAddress < (unsigned char*)HEAP_END) *(unsigned short*)(nextAddress + 2) = (unsigned short)address;

    *(unsigned short*)address = size;
}

