//interface protocols lib
//interface.c

unsigned char I2C_READ(unsigned char address) {
	int i = 0;
	unsigned int response = 0x00;
   // output(0x00);
   // output(0x04);
   out(1,0x02);
   out(4,0x0F); //make sure SCL and SDA are high
   //LAYOUT      VCC|MISO|SDA|X|X|SCL|MOSI|SCK|SDA|GND
   //PIN          10| 09 | 8 |7|6| 5 | 04 | 3 | 2 | 1  
	address|=0x01; //set the LSB is 1 to make it a read
	out(4,0x0E); //drop SDA and keep SCL high, start condition [S]
	out(4,0x06);// drop SCL , we now are ready to send data
				//NOTE1: we assume there is a considareble delay between the first out and this out
				
	
    for(i = 0; i < 8; i++) {
		
        if(address & 0x80) {
			//8421
						 // - |||+ 0100 0000
			out(1,0x02); //be on port B
			out(4,0x07); //so we set SDA high  //here we set this bit first high, then only the clock, its for safety
			out(4,0x0F); //then clock SCL (not here MOSI and SCK are kept high because of the SPI system)
        }else {
           out(1,0x02);//port B
           out(4,0x0E); //set SCL to high and keep SDA low
		   //out(3,0x00);//turn off bit 5
        }
		   out(4,0x06);//drop SCL and SDA until the next part of the loop runs
		/*datain <<= 1;//shift 1
		out(1,0x02);//port C
		if(inp(4)&0x60){
			datain|=0x01;
		}else{
			datain|=0x00;
		}
		out(1,0x02); //be on port B
		out(4,0x02);//turn off bit 5
		out(4,0x00);//turn off bit 5
        data <<= 1;
		//printf("data post shift %x\r\n",data);
		//printf("data inputed %x\r\n",datain);
		*/
    }
	
	//now the not so fun part
	//retrieving the data
	
	out(4,0x07);//set the SDA line high so the device can pull low
	
	//response structure: XXXXXXAADDDDDDDD
	//D= data, A= ack/nack, X = dont care
	out(4,0x0F);//clk SCL
	response=inp(4)&&0x60;//sample SDA
	response<<1;//shift it
	out(4,0x07);
	
	for(i=0;i<8;i++){
		
		out(4,0x0F);//clk SCL
		response|=inp(4)&&0x60;//sample SDA and OR it to response
		response<<1;//shift it
		out(4,0x07);
	}
	
		//for the last ack/nack---------------
	    out(4,0x0F);//clk SCL
		response|=inp(4)&&0x60;//sample SDA and OR it to response
		response<<1;//shift it
		out(4,0x07);
	    //-------------------------------
		out(1,0x02);
		out(4,0x0E); //SCL GOES HIGH
		out(4,0x0F);//SDA GOES HIGH, END OF READ
		
	
	
	return response;
    //output(0x00);
}


unsigned char I2C_WRITE(unsigned char address,unsigned char data){
	
	int i = 0;
	unsigned char ack = 0x00;
	   out(1,0x02);
   out(4,0x0F); //make sure SCL and SDA are high
   //LAYOUT      VCC|MISO|SDA|X|X|SCL|MOSI|SCK|SDA|GND
   //PIN          10| 09 | 8 |7|6| 5 | 04 | 3 | 2 | 1  
	
	out(4,0x0E); //drop SDA and keep SCL high, start condition [S]
	out(4,0x06);// drop SCL , we now are ready to send data
				//NOTE1: we assume there is a considareble delay between the first out and this out
				
	address&=0xFE;//make sure the LSB is 0 so its a write
    for(i = 0; i < 8; i++) {
		
        if(address & 0x80) {
			//8421
						 // - |||+ 0100 0000
			out(1,0x02); //be on port B
			out(4,0x07); //so we set SDA high  //here we set this bit first high, then only the clock, its for safety
			out(4,0x0F); //then clock SCL (not here MOSI and SCK are kept high because of the SPI system)
        }else {
           out(1,0x02);//port B
           out(4,0x0E); //set SCL to high and keep SDA low
		   //out(3,0x00);//turn off bit 5
        }
		   out(4,0x06);//drop SCL and SDA until the next part of the loop runs
    }
	
		//and this is kinda like, rince and repeat
		//retrieving the ack
	
		out(4,0x07);//set the SDA line high so the device can pull low
		out(4,0x0F);//clk SCL
		ack=inp(4)&&0x60;//sample SDA
		ack<<1;//shift it
		out(4,0x06);
	
		for(i = 0; i < 8; i++) {
		
			if(data & 0x80) {
				//8421
						 // - |||+ 0100 0000
				out(1,0x02); //be on port B
				out(4,0x07); //so we set SDA high  //here we set this bit first high, then only the clock, its for safety
				out(4,0x0F); //then clock SCL (not here MOSI and SCK are kept high because of the SPI system)
			}else {
				out(1,0x02);//port B
				out(4,0x0E); //set SCL to high and keep SDA low
				//out(3,0x00);//turn off bit 5
			}
				out(4,0x06);//drop SCL and SDA until the next part of the loop runs
		}
	
		out(4,0x07);//set the SDA line high so the device can pull low
		out(4,0x0F);//clk SCL
		ack|=inp(4)&&0x60;//sample SDA
	
		out(4,0x06);
		
		out(1,0x02);
		out(4,0x0E); //SCL GOES HIGH
		out(4,0x0F);//SDA GOES HIGH, END OF READ
	
}

