;malloc_free.inc

;-DYN MEMORY ALLOCATION------------------------
;-R12-Size--------------------------------------
;-R15-return address---------------------------
;-Local registers------------------------------
;-R5-R6-R7-R8----------------------------------
STACK_REG EQU R2
DYN_MEMORY_ALLOC:
    sex STACK_REG
    
    ghi R8
    stxd
    glo R8
    stxd
    
    ghi R7
    stxd
    glo R7
    stxd
    
    ghi R6
    stxd
    glo R6
    stxd
    
    ghi R5
    stxd
    glo R5
    stxd
    
    ldi 0
    stxd
    stxd                ;+7 currentSize
    
    ghi R4
    stxd
    glo R4
    stxd                ;+5 size
    
    glo R4              ;R4 += 5
    adi 5
    plo R4
    ghi R4
    adci 0
    phi R4
    
    ghi R4
    stxd
    glo R4              ;newSize is initialized to size+5 for further calculation
    stxd                ;+3 newSize

    ldi HEAP_END.1
    stxd
    ldi HEAP_END.0
    stxd                ;+1 endAddress = HEAP_END
    
    ldi HEAP_LASTADDRESS.0
    plo R4
    ldi HEAP_LASTADDRESS.1
    phi R4
    
    lda R4
    plo R5
    lda R4
    phi R5              ;R5 = lastAddress
    
    ldi 0               ;R10 = 0
    plo R10
    phi R10
    
    ldi 2               ;R8 = 2
    plo R8
    
DYN_MEMORY_ALLOC_MAINLOOP:
    glo STACK_REG       ;set R4 pointer to endAddress
    plo R4
    ghi STACK_REG
    phi R4
    inc R4
    
    sex R4
    
    glo R5              ;currentAddress - endAddress
    sm
    irx
    ghi R5
    smb
    
    lbdf DYN_MEMORY_ALLOC_NEXTPASS      ;if currentAddress >= endAddress
    
    glo STACK_REG                       ;set R4 pointer to currentSize
    adi 7
    plo R4
    ghi STACK_REG
    adci 0
    phi R4
    
    glo R5                              ;R6 = R5 (currentAddress)
    plo R6
    ghi R5
    phi R6
    
    lda R6                              ;currentSize = block size
    str R4
    inc R4
    
    lda R6
    str R4
    
    inc R6
    inc R6
        
    ldn R6
    lbnz DYN_MEMORY_ALLOC_NEXTADDRESS   ;if the current block is USED
    
    dec R4
    
    glo STACK_REG                   ;R6 pointer set to size
    adi 5
    plo R6
    ghi STACK_REG
    adci 0
    phi R6
    
    ldn R6                          ;currentSize == size
    sd
    bnz DYN_MEMORY_ALLOC_SIZEBIGGER
    irx
    inc R6
    ldn R6
    sdb

    dec R6                              ;set back R6
    dec R4                              ;set back R4
    
    lbnz DYN_MEMORY_ALLOC_SIZEBIGGER    ;if currentSize != size

DYN_MEMORY_ALLOC_SIZEEQ:
    glo R5                              ;R6 = currentAddress + 4
    adi 4
    plo R6
    ghi R5
    adci 0
    phi R6
    
    ldi 1
    str R6                              ;used = 1
    
    inc R6                              ;R6++
    glo R6
    plo R10                             ;R10 = R6
    ghi R6
    phi R10
    
    lbr DYN_MEMORY_ALLOC_END            ;RETURN

DYN_MEMORY_ALLOC_SIZEBIGGER:
    glo STACK_REG                   ;R6 pinter set to newSize (size+5)
    adi 3
    plo R6
    ghi STACK_REG
    adci 0
    phi R6
    
    lda R6                          ;currentSize - newSize (size+5)
    sd
    irx
    lda R6
    sdb
    
    dec R6                              ;set back R6
    dec R6
       
    lbnf DYN_MEMORY_ALLOC_NEXTADDRESS   ;if currentSize < newSize (size+5)
    
    dec R4                              ;R4 pointer to size
    dec R4
    dec R4
    
    glo R5                              ;R6 = R5 (currentAddress)
    plo R6
    ghi R5
    phi R6
    
    lda R4                              ;set current block size to size
    str R6
    inc R6
    
    lda R4
    str R6
    inc R6
    
    inc R6                              ;R6 += 2
    inc R6
    
    ldi 1                               ;set used to 1
    str R6
    
    inc R6                              ;R6++
    glo R6
    plo R10                             ;R10 = R6
    ghi R6                              ;R10 is set for return
    phi R10
    
    glo STACK_REG                   ;R4 pinter set to newSize (size+5)
    adi 3
    plo R4
    ghi STACK_REG
    adci 0
    phi R4
    
    glo R5                          ;R7 = currentAddress + size + 5
    add
    irx
    plo R7
    ghi R5
    adc
    phi R7                          ;R7 is the newAddress
    
    ldi HEAP_LASTADDRESS.0
    plo R4
    ldi HEAP_LASTADDRESS.1
    phi R4
    
    glo R7                          ;lastAddress = R7
    str R4
    inc R4
    
    ghi R7
    str R4

    glo STACK_REG                   ;R4 pinter set to newSize
    adi 3
    plo R4
    ghi STACK_REG
    adci 0
    phi R4
    
    glo STACK_REG                   ;R4 pinter set to currentSize
    adi 7
    plo R6
    ghi STACK_REG
    adci 0
    phi R6
    
    lda R6                          ;newSize = currentSize - (size + 5)
    sm
    str R4
    irx
    
    lda R6
    smb
    str R4
    
    dec R4                          ;set back R4 to newSize
    
    glo R7                          ;R6 = R7 (newAddress)
    plo R6
    ghi R7
    phi R6
    
    lda R4                          ;new block size = newSize
    str R6
    inc R6
    
    lda R4
    str R6
    inc R6
    
    glo R5                          ;new block previous address = currentAddress
    str R6
    inc R6
    
    ghi R5
    str R6
    inc R6
    
    ldi 0                           ;new block used = 0
    str R6
    inc R6
    
    dec R4
    dec R4
    
    glo R6                          ;R6 = R6 + newSize
    add
    irx
    plo R6
    ghi R6
    adc
    phi R6
    
    inc R6                          ;R6 += 2
    inc R6
    
    glo R6
    smi HEAP_END.0
    ghi R6
    smbi HEAP_END.1
    
    lbdf DYN_MEMORY_ALLOC_END
    
    glo R7                          ;next block previous address = R7
    str R6
    inc R6
    
    ghi R7
    str R6
    
    lbr DYN_MEMORY_ALLOC_END
    
DYN_MEMORY_ALLOC_NEXTADDRESS:
    glo STACK_REG               ;set R4 pointer to currentSize
    adi 7
    plo R4
    ghi STACK_REG
    adci 0
    phi R4
    
    glo R5
    add
    irx
    plo R5
    ghi R5
    adc
    phi R5                          ;currentAddress += size
    
    glo R5
    adi 5
    plo R5
    ghi R5
    adci 0
    phi R5                          ;currentAddress += 5
    
    lbr DYN_MEMORY_ALLOC_MAINLOOP
    
DYN_MEMORY_ALLOC_NEXTPASS:
    ldi HEAP_START.0
    plo R5
    ldi HEAP_START.1
    phi R5
    
    glo STACK_REG                       ;set R4 pointer to endAddress
    plo R4
    ghi STACK_REG
    phi R4
    inc R4
    
    ldi HEAP_LASTADDRESS.0
    plo R6
    ldi HEAP_LASTADDRESS.1
    phi R6
    
    lda R6
    str R4
    inc R4
    
    lda R6
    str R4

    dec R8
    glo R8
    lbnz DYN_MEMORY_ALLOC_MAINLOOP
    
DYN_MEMORY_ALLOC_END:
    glo STACK_REG
    adi 9
    plo STACK_REG
    ghi STACK_REG
    adci 0
    phi STACK_REG
    
    sex STACK_REG
    
    ldxa
    plo R5
    ldxa
    phi R5
    
    ldxa
    plo R6
    ldxa
    phi R6
    
    ldxa
    plo R7
    ldxa
    phi R7
    
    ldxa
    plo R8
    ldx
    phi R8
    
    sep RETURN
;----------------------------------------------

;-DYN MEMORY FREE------------------------------
;-R4-address-----------------------------------
;-Local registers------------------------------
;-R5-R6----------------------------------------
DYN_MEMORY_FREE:
    sex STACK_REG
    
    ghi R5      ;saving local registers
    stxd
    glo R5
    stxd
    
    ghi R6
    stxd
    glo R6
    stxd
    
    ldi 0
    stxd
    stxd
    stxd
    stxd        ;+5 size
    
    stxd
    stxd
    stxd
    stxd        ;+1 nextSize
    
    dec R4      ;R4-- (address--)
    str R4      ;set current block to free
    
    dec R4
    dec R4
    
    lda R4      ;R6 = previous block address
    plo R6
    lda R4
    phi R6
    
    dec R4      ;set R4 to the beginning of the current block
    dec R4
    dec R4
    dec R4
    
    glo R6
    lbnz DYN_MEMORY_FREE_NEXTCHECK
    ghi R6
    lbnz DYN_MEMORY_FREE_NEXTCHECK      ;if previousAddress != 0
    
    br DYN_MEMORY_FREE_MERGE

DYN_MEMORY_FREE_NEXTCHECK
    glo R6                              ;set R5 pointer to previous block used
    adi 4
    plo R5
    ghi R6
    adci 0
    phi R5
    
    ldn R5
    bnz DYN_MEMORY_FREE_MERGE           ;if used != 0
    
    glo R6                              ;set R4 to previous block
    plo R4
    ghi R6
    phi R4
    
DYN_MEMORY_FREE_MERGE
    glo STACK_REG                       ;set R5 pointer to size
    adi 5
    plo R5
    ghi STACK_REG
    adci 0
    phi R5
    
    sex R5                              ;set R5 to pointer
    
    lda R4                              ;load block size to size
    str R5
    inc R5
    
    lda R4
    str R5
    
    dec R4
    dec R4                              ;set back R4 and R5
    dec R5
    
    glo R4                              ;R6 (nextAddress) = address + 5 
    adi 5
    plo R6
    ghi R4
    adci 0
    phi R6
    
    glo R6                              ;R6 += size
    add
    irx
    plo R6
    ghi R6
    adc
    phi R6
    
DYN_MEMORY_FREE_MERGELOOP
    glo R6
    smi HEAP_END.0
    ghi R6
    smbi HEAP_END.1
    
    lbdf DYN_MEMORY_FREE_END            ;if nextAddress - HEAP_END >= 0
    
    glo R6                              ;set R5 to nextAddress used
    adi 4
    plo R5
    ghi R6
    adci 0
    phi R5
    
    ldn R5
    lbnz DYN_MEMORY_FREE_SETPREVIOUS    ;if used != 0
    
    glo STACK_REG                       ;set R5 pointer to nextSize
    plo R5
    ghi STACK_REG
    phi R5
    inc R5
    
    lda R6                              ;load size + 5 to nextSize 
    adi 5
    str R5
    irx
    
    ldn R6
    adci 0
    str R5
    
    dec R5                              ;set back R5 and R6
    dec R6
    
    ldn R4                              ;current block size += nextSize
    add
    str R4
    irx
    inc R4
    
    ldn R4
    adc
    str R4
    
    dec R5                              ;set back R4 and R5
    dec R4
    
    glo R6                              ;R6 (nextAddress) += nextSize
    add
    plo R6
    irx
    ghi R6
    adc
    phi R6
    
    br DYN_MEMORY_FREE_MERGELOOP

DYN_MEMORY_FREE_SETPREVIOUS    
    inc R6                              ;increment nextAddress to previous address section
    inc R6
    
    glo R4                              ;set previous address to R4 value
    str R6
    inc R6
    ghi R4
    str R6

DYN_MEMORY_FREE_END
    glo STACK_REG
    adi 9
    plo STACK_REG
    ghi STACK_REG
    adci 0
    phi STACK_REG
    
    sex STACK_REG
    
    ldi HEAP_LASTADDRESS.0
    plo R5
    ldi HEAP_LASTADDRESS.1
    phi R5
    
    glo R4
    str R5
    inc R5
    
    ghi R4
    str R5
    
    ldxa            ;restoring local registers
    plo R6
    ldxa
    phi R6
    
    ldxa
    plo R5
    ldx
    phi R5
    
    sep RETURN
;----------------------------------------------