;spi_for_interrupt.inc
;
_spi_send_int: ;basic send (entry point for subroutine)

;R12 has the byte
;R13 has the portC mask
;R15, use for tracking

	;be sure we are on port b
	LDI 01	;load 01h to the accumulator(D)
	STR R2	;store it to where R2 points to (free position in stack)
	OUT 1   ;output data pointed by X to IO 1 (R2 is also the X register)
	DEC R2
	;------------


	;to see if this fixes CLK changing prior to CS ;it fixed it, kill me
	GLO R13
	STR R2
	OUT 2
	DEC R2
	;----------------------------------------------

	LDI 08 ;load 8h to the accumulator
	PLO R15 ;put it on the lower part of R15, so we can loop 8 times
$$send_loop_spi_int:
	GLO R12 ;fetch R12 to get the value to send thru SPI (in this case value is loaded to the accumulator)
	ANI 0x80 ;perform an immideat AND on it (result stays on accumulator)
	
	LBZ $$SEND_0_int ;if this gives 0 we branch to $$SEND_0 so we send 0 else we send a 1
$$SEND_1_int:
	GLO R13 ;fetch the bit mask (to not mess with other bits on the io port)
	ORI 0x04; perform an immideat OR on it (result stays on accumulator)
	STR R2 ;store on stack
	OUT 2 ;output it
	DEC R2
	
	
	;this block is so we make sure MOSI has time to get high faster than SCK
	GLO R13 ;fetch the bit mask (to not mess with other bits on the io port)
	ORI 0x06; perform an immideat OR on it (result stays on accumulator)
	STR R2 ;store on stack
	OUT 2 ;output it
	DEC R2
	;------------------------------------------------------------------------
	
	GLO R12 ;get the data byte
	SHL ;shift it left by 1
	PLO R12 ;store the byte back to R12
	
	
	
	GLO R13 ;get the bit mask again
	ANI 0xF0 ;allow it to change the upper nibble but keep lower nibble low
	STR R2;store on stack
	OUT 2;output it
	DEC R2
	
	DEC R15;decrement R15 since we did 1 cycle
	GLO R15;read its value
	
	LBNZ $$send_loop_spi_int ;repeat everything until R15 is 0
	
	
	LBR _display_spi_return
	;Cretn ;leave subroutine
	

$$SEND_0_int:




	;this block is so we make sure MOSI has time to get low faster than SCK
	GLO R13 ;fetch the bit mask (to not mess with other bits on the io port)
	
	STR R2 ;store on stack
	OUT 2 ;output it
	DEC R2
	;------------------------------------------------------------------------



	GLO R13;fetch the bit mask (to not mess with other bits on the io port)
	ORI 0x02; perform an immideat OR on it (result stays on accumulator)
	STR R2;store on stack
	OUT 2;output it
	DEC R2
	
	GLO R12;get the data byte
	SHL;shift it left by 1
	PLO R12;store the byte back to R12
	
	
	GLO R13;get the bit mask again
	ANI 0xF0;allow it to change the upper nibble but keep lower nibble low
	STR R2;store on stack
	OUT 2;output it
	DEC R2
	
	DEC R15;decrement R15 since we did 1 cycle
	GLO R15;read its value
	
	LBNZ $$send_loop_spi_int ;repeat everything until R15 is 0
	
	LBR _display_spi_return
	
	
	;Cretn ;leave subroutine